=== debian/changelog ===
nextcloud-desktop (3.1.1-2+deb11u2) bullseye-security; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * Fix CVE-2022-39331 CVE-2022-39332 CVE-2022-39333 CVE-2022-39334
    CVE-2023-28997.

 -- Abhijith PA <abhijith@debian.org>  Fri, 08 Aug 2025 13:01:11 +0530

nextcloud-desktop (3.1.1-2+deb11u1) bullseye-security; urgency=high

  * Add backported patch to fix CVE-2021-22895 (Closes: #989846).
  * Add backported patch to fix CVE-2021-32728 with small modifications to
    match for Debian.

 -- Sandro Knauß <hefee@debian.org>  Sun, 22 Aug 2021 19:59:32 +0200

nextcloud-desktop (3.1.1-2) unstable; urgency=medium

  * Add two upstream patches to fix CVE-2021-22879 (Closes: #987274):
    013f3cea70acfe7b701cb73c93744d5ff5c0c213
    e97b7d8a25d3ef0d8c52b6399f304a42a5d4f212
    into Validate-sensitive-URLs-to-onle-allow-http-s-schemes.patch
    with small modifications to apply to the version in Debian

 -- Sandro Knauß <hefee@debian.org>  Sat, 08 May 2021 19:39:35 +0200

nextcloud-desktop (3.1.1-1) unstable; urgency=medium

  [ Christian Göttsche ]
  * New upstream version 3.1.1
  * Refresh patches and refactor version patch
  * Add patch to drop Qt5::GuiPrivate dependency
  * Ignore deprecated-declarations warnings
  * Update standards version to 4.5.1, no changes needed.
  * Fix misspelling
  * Please blhc

  [ Sandro Knauß ]
  * Disable updater via CMake BUILD_UPDATER and not via patch.
  * Rename patches to have a clear order.

 -- Sandro Knauß <hefee@debian.org>  Tue, 19 Jan 2021 14:56:40 +0100

nextcloud-desktop (3.0.1-3) unstable; urgency=medium

  * Fix typo: qml-module-qtqml-modules2 -> qml-module-qtqml-models2.
    (Closes: #970900)

 -- Sandro Knauß <hefee@debian.org>  Sat, 26 Sep 2020 13:18:40 +0200

nextcloud-desktop (3.0.1-2) unstable; urgency=medium

  * Add missing qml dependencies. (Closes: #969576)
  * fix typo

 -- Sandro Knauß <hefee@debian.org>  Thu, 24 Sep 2020 21:22:24 +0200

nextcloud-desktop (3.0.1-1) unstable; urgency=medium

  [ Sandro Knauß ]
  * New upstream release (Closes: #968240).
  * Use dh-sequence-addon to simplify rules.
  * Remove upstream applied patch.
  * Update patches.
  * update copyright to reflect changes in 3.0.1.
  * Update lintian-overrides
  * Use jdupes to remove duplicates in doc package.

  [ Christian Göttsche ]
  * Add libqt5svg5-dev and qtquickcontrols2-5-dev to build-dependencies
  * Adjust .desktop installation name

 -- Sandro Knauß <hefee@debian.org>  Wed, 02 Sep 2020 15:27:42 +0200
